Ruby trunk - Bug #7179

10 doc: wrong/misleading text for mode
10/18/2012 12:35 AM - roman-neuhauser (Roman Neuhauser)

Status: Closed

Priority: Normal

Assignee:

Target version: 1.9.3

ruby -v: ruby 1.9.3p194 (2012-04-20 revision Backport:
35410) [x86_64-linux]

Description
affects also 1.9.2,1.9.1,1.8.7

http://www.ruby-doc.org/core-1.9.3/10.html makes the impression
that "b" and "t" are valid on their own, when in fact they're
modifiers and need to be preceded by one of the "real" modes
(a, r, w, and the + variants):

If the mode is given as a String, it must be one of the values
listed in the following table.

notice that "b" and "t" are among the listed values, so they're
clearly permissible, right? (those "may appear" are also quite
clear: "may" implies "does not need to").

Mode Meaning

r Read-only, starts at beginning of file (default mode).

_____ e e
"r+" | Read-write, starts at beginning of file.
_____ e e
"w" | Write-only, truncates existing file

| to zero length or creates a new file for writing.
,,,,, o
"w+" | Read-write, truncates existing file to zero length

| or creates a new file for reading and writing.
_____ e
"a" | Write-only, starts at end of file if file exists,

| otherwise creates a new file for writing.
_____ +________________________________________________________
"a+" | Read-write, starts at end of file if file exists,

| otherwise creates a new file for reading and

|  writing.
,,,,, ]

"b" | Binary file mode (may appear with

| any of the key letters listed above).

|  Suppresses EOL <-> CRLF conversion on Windows. And

| sets external encoding to ASCII-8BIT unless explicitly

| specified.
,,,,, o

"t" | Text file mode (may appear with
\

any of the key letters listed above except "b").

i suggest splitting the table into two and adding a bit of prose
explicitly saying that "b" and "t" cannot be used on their own.

background: i found a few occurrences of File.open(..., "b")
in code by a seasoned ruby programmer who assumed "r" was implied
in this situation.

03/25/2019 1/3



http://www.ruby-doc.org/core-1.9.3/IO.html

Associated revisions

Revision 4d422778 - 11/03/2012 04:27 AM - zzak (Zachary Scott)

e jo.c (IO#new): Documentation for IO#open modes and formatting [ruby-core#48052] [Bug #7179]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@37443 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 37443 - 11/03/2012 04:27 AM - zzak (Zachary Scott)

e jo.c (IO#new): Documentation for IO#open modes and formatting [ruby-core#48052] [Bug #7179]

Revision 37443 - 11/03/2012 04:27 AM - zzak (Zachary Scott)

¢ jo.c (IO#new): Documentation for IO#open modes and formatting [ruby-core#48052] [Bug #7179]

Revision 37443 - 11/03/2012 04:27 AM - zzak (Zachary Scott)

¢ jo.c (IO#new): Documentation for IO#open modes and formatting [ruby-core#48052] [Bug #7179]

Revision 37443 - 11/03/2012 04:27 AM - zzak (Zachary Scott)

e jo.c (IO#new): Documentation for IO#open modes and formatting [ruby-core#48052] [Bug #7179]

Revision 37443 - 11/03/2012 04:27 AM - zzak (Zachary Scott)

¢ jo.c (IO#new): Documentation for IO#open modes and formatting [ruby-core#48052] [Bug #7179]

Revision 37443 - 11/03/2012 04:27 AM - zzak (Zachary Scott)

¢ jo.c (IO#new): Documentation for IO#open modes and formatting [ruby-core#48052] [Bug #7179]

Revision c442d221 - 11/03/2012 04:28 AM - zzak (Zachary Scott)

¢ jo.c (I0O#new): Documentation for IO#open modes and formatting [ruby-core#48052] [Bug #7179]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@37444 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 37444 - 11/03/2012 04:28 AM - zzak (Zachary Scott)

¢ jo.c (I0#new): Documentation for IO#open modes and formatting [ruby-core#48052] [Bug #7179]

Revision 37444 - 11/03/2012 04:28 AM - zzak (Zachary Scott)

¢ jo.c (IO#new): Documentation for IO#open modes and formatting [ruby-core#48052] [Bug #7179]

Revision 37444 - 11/03/2012 04:28 AM - zzak (Zachary Scott)

¢ jo.c (IO#new): Documentation for IO#open modes and formatting [ruby-core#48052] [Bug #7179]

Revision 37444 - 11/03/2012 04:28 AM - zzak (Zachary Scott)

¢ jo.c (I0O#new): Documentation for IO#open modes and formatting [ruby-core#48052] [Bug #7179]

Revision 37444 - 11/03/2012 04:28 AM - zzak (Zachary Scott)

¢ io.c (IO#new): Documentation for IO#open modes and formatting [ruby-core#48052] [Bug #7179]

Revision 37444 - 11/03/2012 04:28 AM - zzak (Zachary Scott)

¢ jo.c (IO#new): Documentation for IO#open modes and formatting [ruby-core#48052] [Bug #7179]
Revision de794aef - 11/09/2012 12:28 AM - zzak (Zachary Scott)

¢ jo.c (IO#new): Fix indentation from r37444 [ruby-core:48052] [Bug #7179]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@37568 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 37568 - 11/09/2012 12:28 AM - zzak (Zachary Scott)

¢ io.c (IO#new): Fix indentation from r37444 [ruby-core:48052] [Bug #7179]
Revision 37568 - 11/09/2012 12:28 AM - zzak (Zachary Scott)

¢ io.c (IO#new): Fix indentation from r37444 [ruby-core:48052] [Bug #7179]
Revision 37568 - 11/09/2012 12:28 AM - zzak (Zachary Scott)

e jo.c (IO#new): Fix indentation from r37444 [ruby-core:48052] [Bug #7179]
Revision 37568 - 11/09/2012 12:28 AM - zzak (Zachary Scott)

¢ jo.c (IO#new): Fix indentation from r37444 [ruby-core:48052] [Bug #7179]
Revision 37568 - 11/09/2012 12:28 AM - zzak (Zachary Scott)

¢ io.c (IO#new): Fix indentation from r37444 [ruby-core:48052] [Bug #7179]
Revision 37568 - 11/09/2012 12:28 AM - zzak (Zachary Scott)

e jo.c (IO#new): Fix indentation from r37444 [ruby-core:48052] [Bug #7179]

History

#1 - 11/03/2012 01:27 PM - zzak (Zachary Scott)
- Status changed from Open to Closed
- % Done changed from 0 to 100

This issue was solved with changeset r37443.
Roman, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.
May Ruby be with you.

® jo.c (IO#new): Documentation for IO#open modes and formatting [ruby-core#48052] [Bug #7179]
